import java.util.Random;

public class GaussianUtil
{
	private static Random r = null; 

	public static double sample()
	{
		return sample(0.0, 1.0); 
	}

	// draw a sample from the gaussian given the (mean, and std deviation)
	public static double sample(double m, double s)
	{
		if(r == null)
			r = new Random(System.currentTimeMillis()); 
		return (s*r.nextGaussian() + m);
	}
	
	// evaluate the gaussian pdf based on (mean, std deviation, and the observation)
	public static double evaluate(double m, double s, double o)
	{
		// this shouldn't happen... 
		// expect a gaussian with reasonable variance...
		if(s == 0)	{
			if(m == o)
				return 1.0; 
			else
				return 0.0; 
		}
			
		return (1.0 / (Math.sqrt(2.0*3.1415927)*s) * Math.exp((o-m)*(o-m) / (-2.0*s*s))); 
	}
};

