import java.lang.Math; 

public class Transform2D {
	double translation_x; 
	double translation_y; 
	double rotation; 
	double scale; 
	int	   flip;

	public Transform2D(double t_x, double t_y, double r, double s, int f)
	{
		translation_x = t_x; 
		translation_y = t_y; 
		rotation = r; 
		scale = s; 
		flip = f; 
	}
	
	public Vector2D toImage(Vector2D m)	{
		Vector2D model = new Vector2D();
		model.x = m.x; 
		model.y = m.y;
		
		if(flip!=0)
			model.y *= -1.0; 
		
		double imgx = Math.cos(rotation) * model.x - Math.sin(rotation) * model.y; 
		double imgy = Math.sin(rotation) * model.x + Math.cos(rotation) * model.y; 
		imgx *= scale; 
		imgy *= scale; 
		imgx += translation_x; 
		imgy += translation_y;
		return new Vector2D (imgx, imgy);  
	}
}