import java.lang.Math; 

public class Vector2D {
	double x;
	double y;
	
	public Vector2D()	{
		x = y = 0; 
	}
	
	public Vector2D(double a, double b){
		x = a;
		y = b;
	}
	
	public Vector2D reverse() {
		return new Vector2D(-x,-y);
	}
	
	public Vector2D add(Vector2D a, Vector2D b){
		return new Vector2D(a.x+b.x,a.y+b.y);
	}
	
	public Vector2D add(Vector2D a){
		return new Vector2D(x+a.x,y+a.y);
	}
	
	public Vector2D subtract(Vector2D a)	{
		return new Vector2D(x-a.x,y-a.y);
	}
	
	public Vector2D multCon(double a){
		return new Vector2D(x*a,y*a);
	}
	
	public double length(){
		return Math.sqrt(x*x+y*y);
	}

	public Vector2D orthogonal(){
		return new Vector2D(y,-x);
	}

	public Vector2D normalize(){
		double n = Math.sqrt(x*x+y*y);
		if(n != 0){
			return new Vector2D(x/n,y/n);
		}else{
			return new Vector2D(x,y);
		}
	}
	
	public double dotproduct(Vector2D v){
		double res = x*v.x + y*v.y; 
		return res; 
	}
	
	public String toString(){
		return "x: " +(int)x+ " y: " + (int)y;
	}
}
