
import java.awt.Color;
import java.util.ArrayList;


//this is an example of what you may write
//you may copy it all, just please choose a different class name
//and make sure it implements the ParticleGenerator Interface
public class YourCode implements ParticleGenerator{
	public static void main(String[] args){
		//sets up the UI and gets things running
		//the string is the location for all the data you are given
		//the next 2 numbers are what data is being graphed
		//***NEW***
		//the final number is the dataset you wish to use
		SlotCarUI a = new SlotCarUI("",10,11, new YourCode(),2);
		a.run();
	}
	
	//get particles is called at every data step.
	//the data field is the data from that step.
	//you return where you want everything to print
	public boolean hasTrackData(){
		return trackData == null;
	}
	public void setTrackData(TrackData t){
		trackData = t;
	}
	
	TrackData trackData = null;
	//the trackData field represents the track
	//do not change it for any reason
	//it will be initialized before the first call to getParticles
	
	public ArrayList<Vector2D> getParticles(ArrayList<Double> data) {
		//********DATA CHANGE******
		// data.get(0) = "FrameId";
		// data.get(1) = "SrvTime";
		// data.get(2) = "ClientTime";
		// data.get(3) = "CarX";
		// data.get(4) = "CarY";
		// data.get(5) = "UnfilteredLoc";
		// data.get(6) = "Roll";
		// data.get(7) = "Pitch";
		// data.get(8) = "Yaw";
		// data.get(9) = "AngleFromIMU";
		// data.get(10) = "FilteredLoc";
		// data.get(11) = "FilteredVel";
		// data.get(12) = "AngleFromVisionAndModel";
		// data.get(13) = "sin(angle_vis)";
		// data.get(14) = "cos(angle_vis)";
		//
		
		//****NEW FUNCTIONS FOR YOU TO USE***
		//SlotCarUI.getTrackLength() returns the track length as a double
		//SlotCarUI.setParticleColors(ArrayList<Color>); sets the color of the particles corisponding to the returned value
		////////example is below
		////////if it is not called, it keeps the color orange.
		
		//***CORRECTION***///
		//this is how you DISPLAY a single particle.  You will need to have your own particles.
		//to display them, make a 2d vector and set it's x and y to the x and y of the particle you want to display
		ArrayList<Vector2D> a = new ArrayList<Vector2D>();
		ArrayList<Color> c = new ArrayList<Color>();
		
		System.out.println(SlotCarUI.getTrackLength());
		
		Vector2D from2D = new Vector2D(data.get(3),data.get(4));
		Vector2D from1D = trackData.pointAtDistance(data.get(10), 0);
		a.add(from1D);
		c.add(Color.blue);
		a.add(from2D);
		c.add(Color.magenta);
		
		SlotCarUI.setParticleColors(c);
		return a;
	}
}
